package eu.mhsl.minenet.minigames.instance.game.minigame.types.stickfight;

import eu.mhsl.minenet.minigames.instance.game.minigame.Minigame;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.ConfigManager;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.GameFactory;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.Option;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.common.NumericOption;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.RestrictionHandler;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.common.MaximalPlayeramountGameRestriction;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.common.MaximalPlayeramountInstanceRestriction;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.common.MinimalPlayeramountGameRestriction;
import eu.mhsl.minenet.minigames.instance.game.minigame.config.restriction.common.MinimalPlayeramountInstanceRestriction;
import net.kyori.adventure.text.Component;
import net.minestom.server.item.Material;

import java.util.Map;

public class StickFightFactory implements GameFactory {
    @Override
    public Component name() {
        return Component.text("Stickfight");
    }

    @Override
    public ConfigManager configuration() {
        return new ConfigManager()
                .addOption(new NumericOption("lenght", Material.SANDSTONE, "Länge", 5, 7, 9, 11));
    }

    @Override
    public RestrictionHandler globalRestrictions() {
        return new RestrictionHandler()
                .addRestriction(new MinimalPlayeramountGameRestriction(2))
                .addRestriction(new MaximalPlayeramountGameRestriction(4));
    }

    @Override
    public Minigame manufacture(Map<String, Option<?>> configuration) {
        return new Stickfight();
    }

    @Override
    public Material symbol() {
        return Material.STICK;
    }
}
